#include <stdio.h>
#include <stdlib.h>

typedef struct _cvor
{
	int vrednost;
	struct _cvor *sledeci;
}cvor;

void greska(char *s)
{
	printf("greska: %s\n", s);
	exit(EXIT_FAILURE);
}

cvor* kreiraj_cvor(int vrednost)
{
	cvor *r = malloc(sizeof(cvor));
	if(r == NULL)
		greska("alokacija");
	r->vrednost = vrednost;
	r->sledeci = NULL;
	
	return r;
}

cvor* oslobodi_listu(cvor* glava)
{
	//jedna lista ima glavu liste i ostatak (rep) liste
	//1 -> 2 -> 3 -> 4 -> NULL
	//glava liste ce biti 1
	//a ostatak 2 -> 3 -> 4 -> NULL
	
	//kada radimo oslobadjanje dobijemo kao arg. glavu liste
	//svi elementi liste su dinamicki alocirani
	//i hocemo da ih oslobodimo
	//i da vratimo novu glavu liste
	//a to ce uvek biti NULL
	
	while(glava != NULL)
	{
		//1 -> 2 -> 3 -> NULL
		cvor *slececi = glava->sledeci;
		free(glava);
		glava = slececi;
	}
	return NULL;
}

cvor* oslobodi_listu_r(cvor* glava)
{
	if(glava == NULL)
		return NULL;
	else
	{
		oslobodi_listu_r(glava->sledeci);
		free(glava);
		return NULL;
	}
}

cvor* dodaj_na_pocetak_liste(cvor *glava, int vrednost)
{
	//kao argumente dobijamo glavu liste i vrednost koju dodajemo
	//a kao povratnu vrednost vracamo novu glavu liste
	//moze i na drugi nacin
	//pogledati u primeru za domaci
	//void dodaj_na_pocetak_liste(cvor **glava, int vrednost)
	
	//ako posaljemo funkciji *glava
	//mozemo da menjamo vrednosti u cvoru glava
	//ali ne mozemo da menjamo adresu na cvor glava
	//ali ako posaljemo **glava
	//mozemo da promenimo adresu glave,
	//odnosno kada dodamo novi element, mozemo da kazemo
	//da je adresa glave taj novi element
	//POGLEDATI PRIMER.PDF ZA DOMACI
	
	cvor *novi = kreiraj_cvor(vrednost);
	novi->sledeci = glava;
	return novi;
}

void ispis(cvor *glava)
{
	while(glava != NULL)
	{
		printf("%d ", glava->vrednost);
		glava = glava->sledeci;
	}
	printf("\n");
}

void ispis_r(cvor *glava)
{	
	if(glava == NULL)
	{
		printf("\n");
		return;
	}
	printf("%d ", glava->vrednost);
	ispis_r(glava->sledeci);
}

cvor* ucitaj_listu()
{
	//na pocetku glava MORA DA SE INICIJALIZUJE NA NULL
	cvor* glava = NULL;
	int x;
	while(1)
	{
		scanf("%d", &x);
		if(x == 0)
			break;
		
		glava = dodaj_na_pocetak_liste(glava, x);
	}
	return glava;
}

cvor *ubaci_na_kraj_liste(cvor *glava, int vrednost)
{
	// (NULL, 5)
	// 5 -> NULL
	
	//1 -> 2 -> 3 -> NULL
		//5 -> NULL
	if(glava == NULL)
		return kreiraj_cvor(vrednost);
	else
	{
		glava->sledeci = 
			ubaci_na_kraj_liste(glava->sledeci, vrednost);
		return glava;
	}
}

cvor* ucitaj_listu_el_na_kraj()
{
	cvor* glava = NULL;
	int x;
	while(1)
	{
		scanf("%d", &x);
		if(x == 0)
			break;
		
		glava = ubaci_na_kraj_liste(glava, x);
	}
	return glava;
}

//iz date liste izbaciti svako pojavljivanje vrednosti b
cvor* izbaci(cvor *glava, int b)
{
	if(glava == NULL)
		return NULL;
	else
	{
		//dva slucaja 
		//1. u glavi se nalazi vrednost b
		//2. u glavi se ne nalazi vrednost b
		if(glava->vrednost == b)
		{
			//ako se u glavi nalazi vrednost b
			//to znaci da treba da izbacimo glavu
			//i vratimo ostatak liste, BEZ VREDNOSTI B
			cvor *sledeci = glava->sledeci;
			free(glava);
			return izbaci(sledeci, b);
		}
		else
		{
			glava->sledeci = 
				izbaci(glava->sledeci, b);
			return glava;
		}
	}
}

cvor* ubaci_sortirano(cvor *glava, int v)
{	
	if(glava == NULL)
		return kreiraj_cvor(v);
	else
	{
		if(glava->vrednost < v)
		{
			glava->sledeci = 
				ubaci_sortirano(glava->sledeci, v);
			return glava;
		}
		else
			return dodaj_na_pocetak_liste(glava, v);
	}
}

cvor* ucitaj_sortirano()
{
	cvor* glava = NULL;
	int x;
	while(1)
	{
		scanf("%d", &x);
		if(x == 0)
			break;
		
		glava = ubaci_sortirano(glava, x);
	}
	return glava;
}

cvor* spoj_sortirano(cvor *g1, cvor *g2)
{
	if(g1 == NULL)
		return g2;
	if(g2 == NULL)
		return g1;
	//ako dodjemo do ove linije znaci da 
	//ni g1 ni g2 nisu NULL, pa mozemo da proveravamo 
	//njihove vrednosti
	if(g1->vrednost < g2->vrednost)
	{
		g1->sledeci = 
			spoj_sortirano(
				g1->sledeci, g2);
		return g1;
	}
	else
	{
		g2->sledeci = 
			spoj_sortirano(
				g1, g2->sledeci);
		return g2;
	}
}

int main()
{
	//1.
	//cvor *glava = ucitaj_listu();
	//ispis(glava);
	//ispis_r(glava);
	
	//2.
	//cvor *glava = ucitaj_listu_el_na_kraj();
	//ispis(glava);
	
	//3.
	//int b;
	//scanf("%d", &b);
	//glava = izbaci(glava, b);
	//ispis(glava);
	
	//glava = oslobodi_listu(glava);
	
	cvor *g1 = ucitaj_sortirano();
	ispis(g1);
	
	cvor *g2 = ucitaj_sortirano();
	ispis(g2);
	
	cvor *g3 = spoj_sortirano(g1, g2);
	ispis(g3);
	
	oslobodi_listu(g3);
	
	return 0;
}