#include <stdio.h>
#include <stdlib.h>

typedef struct _cvor
{
	//bilo koja vrednost ili neka druga
	//stuktura
	//danas na vezbama cemo koristiti 
	//ceo broj kao vrednost cvora
	int vrednost;
	struct _cvor *sledeci;
}cvor;

void greska(char *s)
{
	fprintf(stderr, "greska: %s\n", s);
	exit(EXIT_FAILURE);
}

//cvor a;
//struct _cvor a;

cvor* kreiraj_cvor(int vrednost)
{
	cvor *novi = malloc(sizeof(cvor));
	if(novi == NULL)
		greska("alokacija");
	novi->vrednost = vrednost;
	novi->sledeci = NULL;
	return novi;
}

//Uvek kad radimo sa listama, pamtimo samo glavu liste
//kao kad radimo sa nizovima pamtimo adresu na pocetak
//niza

//kada dodajemo novi el. na pocetak
//glava liste se menja, odnosno menja se adresa na
//pocetak liste

//adresa na pocetak liste je cvor*
//da bi to moglo da se menja u fukciji imamo 2 nacina
//implementacije

//1. da funkciji prosledimo cvor**
//2. funkciji prosledimo cvor*, ali kao rezultat
//	vratimo adresu nove glave liste
cvor* dodaj_na_pocetak_liste(cvor *glava, int vrednost)
{
	cvor *novi = kreiraj_cvor(vrednost);
	novi->sledeci = glava;
	return novi;
	//novi->nesto <=> (*novi).nesto
}

void dodaj_na_pocetak_liste2(cvor **glava, int vrednost)
{
	cvor *novi = kreiraj_cvor(vrednost);
	novi->sledeci = *glava;
	(*glava) = novi;
}

cvor* ucitaj_listu()
{
	//u funkciji se unose brojevi koji se dodaju 
	//u listu, sve dok se ne unese nula
	
	//prazna lista se UVEK INICIJALIZUJE NA NULL
	cvor *glava = NULL;
	int x;
	while(1)
	{
		scanf("%d", &x);
		if(x == 0)
			break;
		
		glava = dodaj_na_pocetak_liste(glava, x);
		//dodaj_na_pocetak_liste2(&glava, x);
	}
	return glava;
}

cvor* dodaj_na_kraj_liste(cvor *glava, int x)
{
	if(glava == NULL)
		return kreiraj_cvor(x);
	else
	{
		//razmisljamo o ostatku liste
		//kao o potpuno novoj listi
		
		//mozemo da pozovemo rekurzivni poziv
		//za ostatak liste
		
		//1 -> 2 -> 3 -> NULL
		//a dodajemo 4
		//pozovemo rekurziju za ostatak
		//dodaj u 2 -> 3 -> NULL vrednost 4
		//ocekujemo kao rez
		//2 -> 3 -> 4 -> NULL
		
		glava->sledeci = 
			dodaj_na_kraj_liste(glava->sledeci, x);
		return glava;
	}
}

cvor* dodaj_na_kraj_liste_i(cvor *glava, int x)
{
	if(glava == NULL)
		return kreiraj_cvor(x);
	
	cvor *zc = glava;
	while(zc->sledeci != NULL)
		zc = zc->sledeci;
	
	zc->sledeci = kreiraj_cvor(x);
	return glava;
}

//1. deo 5. zadtaka
cvor* dodaj_u_sortiranu_listu(cvor *glava, int v)
{
	if(glava == NULL)
		return kreiraj_cvor(v);
	else
	{
		//rastuce 1 -> 2 -> 3...
		if(v < glava->vrednost)
		{
			glava = dodaj_na_pocetak_liste(glava, v);
			return glava;
		}
		else
		{
			glava->sledeci = 
				dodaj_u_sortiranu_listu(glava->sledeci, v);
			return glava;
		}
	}
}

cvor* spoj_sortirano(cvor *g1, cvor *g2)
{
	if(g1 == NULL)
		return g2;
	if(g2 == NULL)
		return g1;
	
	if(g1->vrednost < g2->vrednost)
	{
		g1->sledeci = spoj_sortirano(g1->sledeci, g2);
		return g1;
	}
	else
	{
		g2->sledeci = spoj_sortirano(g1, g2->sledeci);
		return g2;
	}
}

cvor* ucitaj_listu_na_kraj()
{
	cvor *glava = NULL;
	int x;
	while(1)
	{
		scanf("%d", &x);
		if(x == 0)
			break;
		
		glava = dodaj_na_kraj_liste(glava, x);
	}
	return glava;
}

cvor* ucitaj_sortirano()
{
	cvor *glava = NULL;
	int x;
	while(1)
	{
		scanf("%d", &x);
		if(x == 0)
			break;
		
		glava = dodaj_u_sortiranu_listu(glava, x);
	}
	return glava;
}

void ispis(cvor *glava)
{
	//1 -> 2 -> 3 -> NULL
	while(glava != NULL)
	{
		printf("%d ", glava->vrednost);
		glava = glava->sledeci;
		//ovo glava->vrednost ili glava->sledeci
		//je uglavnom uzrok seg. fault u programima
		//moramo ih bezbedno koristiti
		//ako pozovemo bilo gde glava->vrednost
		//MORAMO DA BUDEMO SIGURNI DA glava NIJE NULL
	}
	printf("\n");
}

void ispis_r(cvor *glava)
{
	if(glava == NULL)
		printf("\n");
	else
	{
		printf("%d ", glava->vrednost);
		ispis_r(glava->sledeci);
	}
}

//oslobadjanje memorije koju je lista alocirala
//moramo da oslobodimo svaki cvor posebno

cvor* oslobodi(cvor *glava)
{
	//nije neophodno da funkcija vraca neku vrednost
	//ali je dobra praksa da vrati NULL, kao novu glavu
	//liste
	
	while(glava != NULL)
	{
		//free(glava);
		//glava = glava->sledeci;
		//ovo nije dobro, kada smo jednom rekli
		//free glava, glava->sledeci vise ne postoji
		
		cvor* sledeci = glava->sledeci;
		free(glava);
		glava = sledeci;
	}
	return NULL;
}

cvor* oslobodi_r(cvor *glava)
{
	if(glava == NULL)
		return NULL;
	else
	{
		cvor *sledeci = glava->sledeci;
		free(glava);
		oslobodi_r(sledeci);
	}
}

int duzina(cvor *glava)
{	
	if(glava == NULL)
		return 0;
	else
	{	
		return 1 + duzina(glava->sledeci);
	}
}

cvor* izbaci_b(cvor *glava, int b)
{
	if(glava == NULL)
		return NULL;
	else
	{
		//2 slucaja
		//1. U glavi se nalazi vrednost koju izbacujemo
		//2. U glavi se ne nalazi vrednost koju izbacujemo
		
		//1. 
		if(glava->vrednost == b)
		{
			//preskacemo glavu
			//1->2->3->1.... 1
			//2->3->...
			cvor *sledeci = glava->sledeci;
			free(glava);
			return izbaci_b(sledeci, b);
		}
		else
		{
			glava->sledeci = 
				izbaci_b(glava->sledeci, b);
			return glava;
		}
	}
}

//while(x != 0)
//{
//	lista = dodaj_na_pocetak_liste(lista, x % 10);
//	x = x / 10;
//}

void main()
{
	//1. cvor *glava = ucitaj_listu();
	//2.
	//cvor *glava = ucitaj_listu_na_kraj();
	
	//ispis(glava);
	//ispis_r(glava);
	//printf("duzina je: %d", duzina(glava));
	
	//4:
	//int x;
	//scanf("%d", &x);
	//glava = izbaci_b(glava, x);
	//ispis(glava);
	//glava = oslobodi(glava);
	
	cvor *l1 = ucitaj_sortirano();
	ispis(l1);
	
	cvor *l2 = ucitaj_sortirano();
	ispis(l2);
	
	cvor *l_sort = spoj_sortirano(l1, l2);
	ispis(l_sort);
	
	l_sort = oslobodi(l_sort);
	
	//glava = oslobodi_r(glava);
}